@ECHO OFF
CLS
SET autodetect=1
SET delrfs=1
SET delbaks=1
IF .%1 == . goto typefile
IF .%1 == ./? goto help
SET file=%1
goto checkext

:typefile
ECHO TYPE FILENAME WITH EXTENSION THAT NEEDS TO BE ADDED. 
ECHO LEAVE EMPTY TO CANCEL OPERATION.
STRINGS file=ASK FILENAME TO ADD: [1;36m
STRINGS len=LENGTH %file%>nul
ECHO %clr%
IF %len% == 0 goto cancel
ECHO ---------------------------

:checkext
STRINGS file=UPPER %file%
STRINGS ext=FILEEXT %file%
IF NOT .%ext% == . goto checkexistence
STRINGS ext=FILEDIR %file%
IF %ext% == \ goto typext
STRINGS ext=RIGHT %ext%, 3
STRINGS len=LENGTH %ext%
IF %len% == 0 goto typext
SET file=%file%.%ext%
SET extd=1
goto checkexistence

:typext
CLS
ECHO THE EXTENSION OF [1;36m%file%%clr% IS REQUIRED. PLEASE TYPE.
ECHO LEAVE EMPTY TO CANCEL OPERATION.
STRINGS ext=ASK EXTENSION OF FILE: [1;36m
STRINGS len=LENGTH %ext%>nul
ECHO %clr%
IF %len% == 0 goto cancel
STRINGS ext=UPPER %ext%>nul
SET file=%file%.%ext%
ECHO ---------------------------

:checkexistence
IF NOT EXIST %file% goto nofile
STRINGS sl=FIND %file%, \
STRINGS sl2=FIND %file%, /
STRINGS sl3=FIND %file%, :
STRINGS sl=ADD %sl%,%sl2%,%sl3%
IF     %sl% == 0 SET str=resource "%_CWDS%%file%"
IF NOT %sl% == 0 SET str=resource "%file%"
STRINGS file=UPPER %file%>nul
goto asid

:asid
ECHO.
IF .%3 == ./ goto noid
IF NOT .%3 == . goto argid
ECHO TYPE RESOURCE ID FOR [1;36m%file%%clr% AND PRESS ENTER.
ECHO LEAVE EMPTY IF ID DOES NOT REQUIRED.
STRINGS id=ASK RESOURCE ID: [1;36m
STRINGS len=LENGTH %id%>nul
ECHO %clr%
ECHO ---------------------------
IF %ext% == RAW goto noid
IF %len% == 0 goto noid
:setid
SET str=%str% as %id%;
goto pext
:noid
SET str=%str%;
goto pext

:argid
SET id=%3
IF NOT %ext% == RAW goto setid
IF     %ext% == RAW goto noid

:pext
IF %ext% == RAW goto rawvol

:rawhere
IF NOT .%autodetect% == .1 goto selarch
IF %ext% == RAW goto srff
IF %ext% == MID goto srff
IF %ext% == QFN goto grff
IF %ext% == QBM goto grff
IF %ext% == MNU goto grff
goto brff


:selarch
ECHO.
IF .%2 == . goto selarchshow
IF %2 == / goto selarchshow
IF %2 == \ goto crff
STRINGS rff=UPPER %2
STRINGS rff=FILENAME %rff%
:selarchshow
IF .%rff% == .BLOOD goto brff
IF .%rff% == .SOUNDS goto srff
STRINGS len=LENGTH %rff%
IF NOT %len% == 0 goto prebarf
SET rff=
IF NOT %id% == . ECHO SELECT RFF ARCHIVE WHERE [1;36m%file%%clr% ([1;35mID: %id%%clr%) SHOULD BE ADDED:
IF %id% == .     ECHO SELECT RFF ARCHIVE WHERE [1;36m%file%%clr% SHOULD BE ADDED:
ECHO.
ECHO [33m[1] [36mBLOOD.RFF       [33m[2] [36mSOUNDS.RFF
ECHO [33m[3] [36mTYPE...         [33m[Q] [36mCANCEL
ECHO.
ECHO ---------------------------
CHOICE /C:123q /N "">nul
IF ERRORLEVEL 4 GOTO cancel
IF ERRORLEVEL 3 GOTO crff
IF ERRORLEVEL 2 GOTO srff
IF ERRORLEVEL 1 GOTO brff

:brff
SET rff=BLOOD.RFF
goto barf

:srff
SET rff=SOUNDS.RFF
goto barf

:grff
SET rff=GUI.RFF
goto barf

:crff
ECHO.
IF NOT .%id% == . ECHO TYPE NAME OF RFF ARCHIVE WHERE [1;36m%file%%clr% ([1;35mID: %id%%clr%) SHOULD BE ADDED:
IF .%id% == .     ECHO TYPE NAME OF ARCHIVE WHERE [1;36m%file%%clr% SHOULD BE ADDED:
ECHO LEAVE EMPTY TO CANCEL OPERATION.
STRINGS rff=ASK RESOURCE ARCHIVE: [1;36m
ECHO %clr%
STRINGS len=LENGTH %rff%>nul
IF %len% == 0 goto cancel
STRINGS rff=FILENAME %rff%
SET rff=%rff%.RFF
goto barf

:prebarf
SET rff=%rff%.RFF

:barf
cd \
IF NOT EXIST BARF.EXE CALL ITOOLS rff
IF NOT EXIST %rff% SET file=%rff%
IF NOT EXIST %rff% goto nofile
ECHO %str%>___.RFS
IF NOT .%sfx% == . ECHO %sfx%>>___.RFS
TYPE \VC\SMCN.SYM>>___.RFS
CLS
ECHO [1;36m
barf %rff% -a @___.RFS
goto end_all



:rawvol
CLS
ECHO.
IF .%id% == . goto selarch
ECHO TYPE VOLUME OF [1;36m%file%%clr%. FROM 0 TO 255.
ECHO LEAVE EMPTY TO USE 100.
STRINGS vol=ASK VOLUME: [1;36m
STRINGS len=LENGTH %vol%>nul
IF %len% == 0 SET vol=100
ECHO %clr%
ECHO ---------------------------

:rawpitch
ECHO.
ECHO TYPE PITCH OF [1;36m%file%%clr%. FOR EXAMPLE, 0x10000.
ECHO LEAVE EMPTY TO USE 0x10000.
STRINGS pitch=ASK PITCH: [1;36m
STRINGS len=LENGTH %pitch%>nul
IF %len% == 0 SET pitch=0x10000
ECHO %clr%
ECHO ---------------------------

:rawformat
ECHO.
ECHO TYPE FORMAT OF [1;36m%file%%clr%. 1=11025 OR 5=22050.
ECHO LEAVE EMPTY TO USE 1.
STRINGS form=ASK FORMAT: [1;36m
STRINGS len=LENGTH %form%>nul
IF %len% == 0 SET form=1
ECHO %clr%
ECHO ---------------------------

:rawloop
ECHO TYPE LOOP POSITION IN MS. -1 MEANS NO LOOP.
ECHO LEAVE EMPTY TO USE -1.
STRINGS loop=ASK LOOP POSITION: [1;36m
STRINGS len=LENGTH %loop%>nul
IF %len% == 0 SET loop=-1
ECHO %clr%
CLS
STRINGS fname=FILENAME %file%
SET sfx=data "%fname%.SFX" as %id%:	%vol%,	%pitch%,	0x0,	%form%,	%loop%,	"%fname%";
goto rawhere

:help
CLS
ECHO.
ECHO  QUICK USAGE: radd [filename].[ext] [rff] [resId]
ECHO  EXAMPLE1: radd myfile.qav blood 55
ECHO           - will add myfile.qav to blood.rff with id 55.
ECHO  EXAMPLE2: radd myfile / 65 
ECHO            - will ask for file extension, then adds myfile.ext in 
ECHO              associated rff archive with id 65.
ECHO.
ECHO  NOTE: radd smart enough to work from any directory.
ECHO  If you place file in directory that named with file extension,
ECHO  you don't even need to type file extension.
ECHO  EXAMPLE: radd dir1\dir2\kvx\myfile
ECHO           - will auto-detect extension as KVX.
ECHO  ------------------------------------------------------------
ECHO.
ECHO  MID and RAW goes to SOUNDS.RFF
ECHO  QFN, QBM and MNU goes to GUI.RFF
ECHO  All other files goes to BLOOD.RFF by default.
ECHO.
ECHO  ------------------------------------------------------------
ECHO  No need auto detect in what archive to add? 
ECHO  Comment autodetect variable above.
goto end_all

:nofile
ECHO.
ECHO [1;31mTHERE IS NO [1;36m%file%[1;31m FOUND.
IF .%extd% == .1 ECHO TRY TYPE FILENAME WITH EXTENSION.
goto end_all


:cancel
ECHO.
ECHO [1;31mABORTED BY THE USER!

:end_all
IF NOT .%delbaks% == .1 goto delrfs
IF EXIST %rff%.BAK DEL %rff%.BAK
IF NOT .%delrfs% == .1 goto end_all_all
IF EXIST ___.RFS DEL ___.RFS>nul
:end_all_all
SET autodetect=
SET delrfs=
SET delbaks=
SET file=
SET ext=
SET len=
SET id=
SET rff=
SET sl=
SET sl2=
SET sl3=
SET vol=
SET fname=
SET pitch=
SET loop=
SET extd=
popd